import { ParserSyntaxError } from '../../shared';
type FindModifier = {
    method: 'skip' | 'filter' | 'min' | 'max' | 'returnKey' | 'showRecordId' | 'limit' | 'hint';
    parameters: unknown;
} | {
    method: 'sort';
    parameters?: unknown;
    options?: unknown;
};
interface FindCommand {
    method: 'find';
    collectionName: string;
    parameters?: unknown;
    options?: unknown;
    explain?: {
        parameters?: unknown;
    };
    modifiers: FindModifier[];
}
interface FindOneCommand {
    method: 'findOne';
    collectionName: string;
    parameters?: unknown;
    options?: unknown;
}
interface FindOneAndDeleteCommand {
    method: 'findOneAndDelete';
    collectionName: string;
    parameters: unknown;
    options?: unknown;
}
interface FindOneAndReplaceCommand {
    method: 'findOneAndReplace';
    collectionName: string;
    parameters: unknown;
    replacement: unknown;
    options?: unknown;
}
interface FindOneAndUpdateCommand {
    method: 'findOneAndUpdate';
    collectionName: string;
    parameters: unknown;
    newValues: unknown;
    options?: unknown;
}
interface InsertOneCommand {
    method: 'insertOne';
    collectionName: string;
    document: unknown;
    options: unknown;
}
interface InsertManyCommand {
    method: 'insertMany';
    collectionName: string;
    documents: unknown;
    options: unknown;
}
type Command = FindCommand | FindOneCommand | FindOneAndDeleteCommand | FindOneAndReplaceCommand | FindOneAndUpdateCommand | InsertOneCommand | InsertManyCommand;
export interface ParsingError {
    type: 'parsingError';
    message: string;
}
export interface UnexpectedError {
    type: 'unexpectedError';
    message: unknown;
}
type ExtractMongoCommandsFromQueryResult = {
    commands: Command[];
} | {
    parseSyntaxErrors: ParserSyntaxError[];
} | {
    parseCommandsError: ParsingError | UnexpectedError;
};
export declare function extractMongoCommandsFromQuery(query: string): ExtractMongoCommandsFromQueryResult;
export {};
